from scapy.all import *
from scapy.layers.inet import IP
from scapy.layers.smb import SMB_Header
from gns3manager import *
import gns3manager


# def duplicate_project(project_name):
#     global PROJECT_ID, username, password
#     url = "http://localhost:3080/v2/projects/" + PROJECT_ID + "/duplicate"
#     data = {"name": project_name.replace(".gns3", "") + "-2"}
#
#     response = requests.post(url, json=data, auth=(username, password))
#     if response.status_code == 201:
#         json_data = response.json()
#         for project in json_data:
#             if project["status"] == "opened":
#                 print(project["filename"])
#                 return project["project_id"], project["filename"]
#     else:
#         print(f"Error duplicate_project: {response.status_code}")


# def get_node(node_id):
#     global PROJECT_ID, username, password
#
#     url = f"http://localhost:3080/v2/projects/{PROJECT_ID}/nodes/{node_id}"
#     response = requests.get(url, auth=(username, password))
#
#     if response.status_code == 200:
#         json_data = response.json()
#         return json_data
#     else:
#         print(f"Error get_node: {response.status_code}")


def process_packet(pkt):
    global array_point, continue_sniffing, malware_instance, is_infected, map_infecting, map_infector
    if SMB_Header in pkt:
        if not is_infected and pkt[SMB_Header].Command == 0xa0 and pkt[SMB_Header].Flags == 0x18:
            victim_ip = pkt[IP].dst
            infecting_ip = pkt[IP].src
            if victim_ip not in map_infecting.keys():
                map_infecting[victim_ip] = [infecting_ip]
            elif infecting_ip not in map_infecting[victim_ip]:
                map_infecting[victim_ip].append(infecting_ip)
            output_file = "infecting.txt"
            with open(output_file, "w") as f:
                json.dump(map_infecting, f)

        if (malware_instance == 0 and pkt[SMB_Header].MID == 81) or (
                malware_instance == 1 and pkt[SMB_Header].Reserved == 0x0011):
            array_point.append(pkt[IP].src + "," + pkt[IP].dst)
            if pkt[IP].src not in map_infector:
                map_infector[pkt[IP].src] = 1
            else:
                input("Error" + pkt[IP].src)
            print("saved", pkt[IP].src, " - ", pkt[IP].dst, "- size", len(array_point))

            output_file = "infector.txt"
            with open(output_file, "w") as f:
                f.write(str(array_point))
            continue_sniffing = False
            is_infected = True


if __name__ == "__main__":
    gns3manager.PROJECT_ID, project_name = GNS3Manager.get_projectId()
    user_input = input("Press enter if Correct project to rennder?")
    if user_input != '':
        sys.exit()

    if len(sys.argv) > 1:
        command = sys.argv[1]
        if command == "1":
            my_templates = GNS3Manager.get_templates()
            array_existing_nodes = GNS3Manager.get_nodes()
            array_window_hosts = []
            # array_switches = []
            array_dhcp_unikernel = []
            array_ubuntu_base = []
            array_ubuntu_intermediate = []
            router_0 = Node(1, 1, "", ROUTER_TYPE)
            ubuntu_server = Node(1, 1, "", UBUNTU_TYPE)
            ubuntu_vc_server = Node(1, 1, "", UBUNTU_VC_SERVER_TYPE)

            for exist_node in array_existing_nodes:
                if exist_node[1] == "R1":
                    router_0.id = exist_node[0]
                    x_node = exist_node[2]
                    y_node = exist_node[3]
                    z_node = exist_node[4]
                elif "VC_Server_Ubuntu20.04" in exist_node[1]:
                    ubuntu_vc_server.id = exist_node[0]
                    x_node = exist_node[2]
                    y_node = exist_node[3]
                    z_node = exist_node[4]
                elif "Ubuntu_Server_Ubuntu18.04" in exist_node[1]:
                    ubuntu_server.id = exist_node[0]
                    x_node = exist_node[2]
                    y_node = exist_node[3]
                    z_node = exist_node[4]
                elif ("WannaCry_Attacker_Win7" in exist_node[1]) or ("WannaCry_Victim_Win7" in exist_node[1]) or ("NotPetya_Attacker_Win7" in exist_node[1]) or (
                        "NotPetya_Victim_Win7" in exist_node[1]):
                    array_window_hosts.append(Node(1, 1, exist_node[0], WINDOW_TYPE))
                    x_node = exist_node[2]
                    y_node = exist_node[3]
                    z_node = exist_node[4]
                elif "dhcp-unikernel-mirageOS" in exist_node[1]:
                    array_dhcp_unikernel.append(Node(1, 1, exist_node[0], DHCP_UNIKERNEL_TYPE))
                    x_node = exist_node[2]
                    y_node = exist_node[3]
                    z_node = exist_node[4]
                elif exist_node[1].startswith("Node_Ubuntu20.04"):
                    array_ubuntu_base.append(Node(1, MAX_SIZE_OF_UBUNTU_BASE_PORT, exist_node[0], UBUNTU_BASE_TYPE))
                    x_node = exist_node[2]
                    y_node = exist_node[3]
                    z_node = exist_node[4]
                elif "Intermediate_Node_Ubuntu20.04" in exist_node[1]:
                    array_ubuntu_intermediate.append(Node(1, MAX_SIZE_OF_UBUNTU_BASE_PORT, exist_node[0], UBUNTU_INTERMEDIATE_TYPE))
                    x_node = exist_node[2]
                    y_node = exist_node[3]
                    z_node = exist_node[4]

            # print("Number of switches:", NUM_SWITCH)
            print("Number of PCs:", len(array_window_hosts))
            print("Number of DHCP unikernel:", len(array_dhcp_unikernel))
            print("Number of ubuntu base:", len(array_ubuntu_base))
            print("Number of ubuntu intermediate:", len(array_ubuntu_intermediate))

            # Press y to start Ubuntu VC server and dhcp
            if input("Start Ubuntu VC Server and DHCP (y/N)?") != "y":
                sys.exit()
            GNS3Manager.start_node(ubuntu_vc_server.id)
            for host in array_dhcp_unikernel:
                GNS3Manager.start_node(host.id)

            # Press y to start Ubuntu bases
            if input("Start Ubuntu Switch nodes (y/N)?") != "y":
                sys.exit()
            for host in array_ubuntu_base:
                time.sleep(1)
                GNS3Manager.start_node(host.id)
            for host in array_ubuntu_intermediate:
                time.sleep(1)
                GNS3Manager.start_node(host.id)

            # Enter y to start router R1 and ubuntu server
            if input("Start Ubuntu Server and Router (y/N)?") != "y":
                sys.exit()
            GNS3Manager.start_node(router_0.id)
            GNS3Manager.start_node(ubuntu_server.id)

            # Capture packets from communications/links
            if input("Capture link (y/N)?") == "y":
                array_links = GNS3Manager.get_links()
                for link in array_links:
                    if ubuntu_server.id not in link and router_0.id not in link and array_window_hosts[0].id not in link:
                        GNS3Manager.start_capture_link(link[0])

            # Press y to start Windows PCs
            if input("Start Windows PCs (y/N)?") != "y":
                sys.exit()
            for host in array_window_hosts:
                time.sleep(1)
                GNS3Manager.start_node(host.id)

            # TCP listen on port 12345 to collect propagation time data
            command = "nc -l -p 12345 > measurement.txt"
            try:
                subprocess.run(command, shell=True, check=True)
                print("Command executed successfully.")
                GNS3Manager.nocapture()  # Stop capturing packets after receiving data
                # Store data in a .zip
                subprocess.run("zip a.zip ~/GNS3/projects/" + project_name.replace(".gns3", "") + "/project-files/captures/*", shell=True, check=True)
            except subprocess.CalledProcessError as e:
                print(f"Error executing command: {e}")
