import requests
import sys
import time

username = "admin"
password = "gjLdHjX0zOiN33qypgN5NDkCga5jeEmjZCWPqV8TtpRtJV4LuGz725nheLbEnyDv"

PROJECT_ID = ""
malware_instance = ""
MAX_SIZE_OF_SWITCH_PORT = 53
MAX_SIZE_OF_UBUNTU_BASE_PORT = 11
SWITCH_TYPE = 1
UBUNTU_TYPE = 2
WINDOW_TYPE = 3
ROUTER_TYPE = 4
DHCP_UNIKERNEL_TYPE = 5
UBUNTU_BASE_TYPE = 6
UBUNTU_INTERMEDIATE_TYPE = 7
UBUNTU_VC_SERVER_TYPE = 8
UBUNTU_UNCTRL_TYPE = 9

LIST_MULTIPLE_PORT = [SWITCH_TYPE, WINDOW_TYPE, ROUTER_TYPE]
LIST_MULTIPLE_ADAPTER = [UBUNTU_TYPE, DHCP_UNIKERNEL_TYPE, UBUNTU_BASE_TYPE, UBUNTU_INTERMEDIATE_TYPE, UBUNTU_VC_SERVER_TYPE, UBUNTU_UNCTRL_TYPE]


class GNS3Manager:
    @staticmethod
    def get_projectId():
        global username, password
        url = "http://localhost:3080/v2/projects"
        response = requests.get(url, auth=(username, password))

        if response.status_code == 200:
            json_data = response.json()
            for project in json_data:
                if project["status"] == "opened":
                    print(project["filename"])
                    return project["project_id"], project["filename"]
        else:
            print(f"Error get_projectId: {response.status_code}")

    @staticmethod
    def link_host_to_host(host_id_1, adapter_number_1, port_number_1, host_id_2, adapter_number_2, port_number_2):
        global PROJECT_ID, username, password
        url = f"http://localhost:3080/v2/projects/{PROJECT_ID}/links"

        data = {"nodes": [{"adapter_number": adapter_number_1, "node_id": host_id_1, "port_number": port_number_1},
                          {"adapter_number": adapter_number_2, "node_id": host_id_2, "port_number": port_number_2}]}
        response = requests.post(url, json=data, auth=(username, password))
        if response.status_code == 201:
            json_data = response.json()
        else:
            print(f"Error link_host_to_host: {response.status_code}")
            print("Error message:", response.text)

    @staticmethod
    def get_nodes():
        global PROJECT_ID, username, password
        url = f"http://localhost:3080/v2/projects/{PROJECT_ID}/nodes"

        response = requests.get(url, auth=(username, password))

        if response.status_code == 200:
            json_data = response.json()

            nodes = []
            for i_json in json_data:
                nodes.append([i_json["node_id"], i_json["name"], i_json["x"], i_json["y"], i_json["z"]])
            return nodes
        else:
            print(f"Error get_nodes: {response.status_code}")

    @staticmethod
    def start_nodes(nodes, node_str):
        for node in nodes:
            GNS3Manager.start_node(node.id, node_str)
            time.sleep(0.2)

    @staticmethod
    def start_node(node_id, node_str):
        global PROJECT_ID, username, password
        url = f"http://localhost:3080/v2/projects/{PROJECT_ID}/nodes/{node_id}/start"
        response = requests.post(url, auth=(username, password))
        if response.status_code == 200:
            print(f"start {node_str}: {node_id}")
        else:
            print(f"Error start_node: {response.status_code}")

    @staticmethod
    def create_switch(port_number, x, y, z):
        global PROJECT_ID, username, password
        url = f"http://localhost:3080/v2/projects/{PROJECT_ID}/nodes"

        data = {'command_line': None, 'compute_id': 'local', 'console_auto_start': False, 'console_host': 'localhost', 'custom_adapters': [], 'first_port_name': None, 'height': 32,
                'label': {'rotation': 0, 'style': 'font-family: TypeWriter;font-size: 10.0;font-weight: bold;fill: #000000;fill-opacity: 1.0;', 'text': 'Switch', 'x': -30,
                          'y': -39}, 'locked': False, 'name': 'Switch{0}', 'node_directory': None, 'node_type': 'ethernet_switch', 'port_name_format': 'Ethernet{0}',
                'port_segment_size': 0, 'symbol': ':/symbols/ethernet_switch.svg', 'template_id': '1966b864-93e7-32d5-965f-001384eec461', 'x': x, 'y': y, 'z': z,
                'properties': {'ports_mapping': []}}

        for i_port in range(port_number):
            data["properties"]["ports_mapping"].append({'name': 'Ethernet' + str(i_port), 'port_number': i_port, 'type': 'access', 'vlan': 1})

        response = requests.post(url, json=data, auth=(username, password))

        if response.status_code == 201:
            json_data = response.json()
            return json_data["node_id"]
        else:
            print(f"Error create_switch: {response.status_code}")

    @staticmethod
    def get_templates():
        global PROJECT_ID, username, password
        url = f"http://localhost:3080/v2/templates"
        response = requests.get(url, auth=(username, password))
        if response.status_code == 200:
            json_data = response.json()
            templates = {}
            for i_json in json_data:
                templates[i_json["name"]] = i_json["template_id"]
            return templates
        else:
            print("Error message:", response.text)

    @staticmethod
    def create_from_template(template_id, x, y):
        url = f"http://localhost:3080/v2/projects/{PROJECT_ID}/templates/{template_id}"
        data = {'x': x, 'y': y}
        response = requests.post(url, json=data, auth=(username, password))

        if response.status_code == 201:
            json_data = response.json()
            return json_data["node_id"]
        else:
            print(f"Error create_from_template: {response.status_code}")
            print("Error message:", response.text)

    @staticmethod
    def create_ubuntu_base(x, y):
        global PROJECT_ID, username, password, my_templates
        template_id = my_templates["U_Router"]
        return GNS3Manager.create_from_template(template_id, x, y)

    @staticmethod
    def create_ubuntu_unctrl(x, y):
        global PROJECT_ID, username, password, my_templates
        template_id = my_templates["Unctrl_Router"]
        return GNS3Manager.create_from_template(template_id, x, y)

    @staticmethod
    def create_ubuntu_vc_server(x, y):
        global PROJECT_ID, username, password, my_templates
        template_id = my_templates["VC_Server_Ubuntu20.04"]
        return GNS3Manager.create_from_template(template_id, x, y)

    @staticmethod
    def create_ubuntu_intermediate(x, y):
        global PROJECT_ID, username, password, my_templates
        template_id = my_templates["Intermediate_Node_Ubuntu20.04"]
        return GNS3Manager.create_from_template(template_id, x, y)

    @staticmethod
    def create_window(x, y, is_attacker):
        global PROJECT_ID, username, password, my_templates, malware_instance

        template_id = my_templates[("NotPetya_Attacker_Win7" if is_attacker else "NotPetya_Victim_Win7") if malware_instance else (
            "Attacker_Win7" if is_attacker else "Victim_Win7")]
        return GNS3Manager.create_from_template(template_id, x, y)

    @staticmethod
    def create_unikernel(x, y, node_type):
        global PROJECT_ID, username, password, my_templates
        template_id = ""
        if node_type == DHCP_UNIKERNEL_TYPE:
            template_id = my_templates["dhcp-unikernel-mirageOS"]
        return GNS3Manager.create_from_template(template_id, x, y)

    @staticmethod
    def create_ubuntu_server(x, y):
        global PROJECT_ID, username, password, my_templates
        template_id = my_templates["Ubuntu_Server_Ubuntu18.04"]
        return GNS3Manager.create_from_template(template_id, x, y)

    @staticmethod
    def duplicate_node(node_id, x, y, z):
        global PROJECT_ID, username, password
        url = f"http://localhost:3080/v2/projects/{PROJECT_ID}/nodes/{node_id}/duplicate"
        data = {"x": x, "y": y, "z": z}
        response = requests.post(url, json=data, auth=(username, password))
        if response.status_code == 201:
            json_data = response.json()
            node_id = json_data["node_id"]
        else:
            print(f"Error duplicate_node: {response.status_code}")
        return node_id

    @staticmethod
    def set_link_filter(link_id, packet_lost):
        global PROJECT_ID, username, password
        url = f"http://localhost:3080/v2/projects/{PROJECT_ID}/links/{link_id}"

        data = {"filters": {"packet_lost": [packet_lost]}}

        response = requests.post(url, json=data, auth=(username, password))

        if response.status_code == 201:
            json_data = response.json()
            return json_data["link_id"]
        else:
            print(f"Error set_link_filter: {response.status_code}")

    @staticmethod
    def get_links():
        global PROJECT_ID, username, password
        url = f"http://localhost:3080/v2/projects/{PROJECT_ID}/links"

        response = requests.get(url, auth=(username, password))

        if response.status_code == 200:
            json_data = response.json()

            links = []
            for i_json in json_data:
                links.append([i_json["link_id"], i_json["nodes"][0]["node_id"], i_json["nodes"][1]["node_id"]])
            return links
        else:
            print(f"Error get_links: {response.status_code}")

    @staticmethod
    def start_capture_link(link_id):
        global PROJECT_ID, username, password
        url = f"http://localhost:3080/v2/projects/{PROJECT_ID}/links/" + link_id + "/start_capture"

        response = requests.post(url, auth=(username, password))
        if response.status_code == 201:
            print("capture link " + link_id)
        else:
            print(f"Error start_capture_link: {response.status_code}")

    @staticmethod
    def stop_capture_link(link_id):
        global PROJECT_ID, username, password
        url = f"http://localhost:3080/v2/projects/{PROJECT_ID}/links/" + link_id + "/stop_capture"

        response = requests.post(url, auth=(username, password))
        if response.status_code == 201:
            print("Stop capture link " + link_id)
        else:
            print(f"Error stop_capture_link: {response.status_code}")

    @staticmethod
    def del_link(link_id):
        global PROJECT_ID, username, password
        url = f"http://localhost:3080/v2/projects/{PROJECT_ID}/links/" + link_id

        response = requests.delete(url, auth=(username, password))
        if response.status_code == 204:
            print("Deleted link " + link_id)
        else:
            print(f"Error del_link: {response.status_code}")

    @staticmethod
    def nocapture():
        links = GNS3Manager.get_links()
        for li in links:
            GNS3Manager.stop_capture_link(li[0])

    @staticmethod
    def get_node(node_id):
        global PROJECT_ID, username, password

        url = f"http://localhost:3080/v2/projects/{PROJECT_ID}/nodes/{node_id}"
        response = requests.get(url, auth=(username, password))

        if response.status_code == 200:
            json_data = response.json()
            return json_data
        else:
            print(f"Error get_node: {response.status_code}")


class Node:
    port_free = 0
    adapter_free = 0
    port_size = 1
    adapter_size = 1
    type = 0

    def __init__(self, port_size, adapter_size, id, type):
        self.port_size = port_size
        self.adapter_size = adapter_size
        self.id = id
        self.type = type

    def update_adapter_free(self):
        self.adapter_free += 1

    def update_port_free(self):
        self.port_free += 1

    def check_port_free(self):
        if self.port_free >= self.port_size:
            print("Error: exceed maximum node port")
            sys.exit()

    def check_adapter_free(self):
        if self.adapter_free >= self.adapter_size:
            print("Error: exceed maximum node adapter")
            sys.exit()

    def connect(self, node):
        if not node:
            return

        adapter_number_1 = 0
        port_number_1 = 0
        adapter_number_2 = 0
        port_number_2 = 0

        if self.type in LIST_MULTIPLE_PORT:
            self.check_port_free()
            port_number_1 = self.port_free
            self.update_port_free()
        elif self.type in LIST_MULTIPLE_ADAPTER:
            self.check_adapter_free()
            adapter_number_1 = self.adapter_free
            self.update_adapter_free()

        if node.type in LIST_MULTIPLE_PORT:
            node.check_port_free()
            port_number_2 = node.port_free
            node.update_port_free()
        elif node.type in LIST_MULTIPLE_ADAPTER:
            node.check_adapter_free()
            adapter_number_2 = node.adapter_free
            node.update_adapter_free()

        GNS3Manager.link_host_to_host(self.id, adapter_number_1, port_number_1, node.id, adapter_number_2, port_number_2)
        return port_number_1, adapter_number_1, port_number_2, adapter_number_2


my_templates = GNS3Manager.get_templates()
