#include "../common/thread.h"
#include "../libITG/ITGapi.h"
#include <stdio.h>
#include <string.h>
#include <cstdlib>

#ifdef UNIX
#include <pthread.h>
#endif

#include "ITGManager.h"

char host[] = "localhost";
char nameProgram[] = "ITGManager";

#define MAX_LINE_LENGTH 1024
#define FILE_PATH "/home/osboxes/D-ITG-2.8.1-r1023-src/D-ITG-2.8.1-r1023/bin/commands.txt"


void Terminate(int sig)
{
#ifdef UNIX
	exit(1);
#endif
#ifdef WIN32
	ExitProcess(0);
#endif
}

int main() {
    FILE *file = fopen(FILE_PATH, "r");
    if (!file) {
        perror("Error opening file");
        return 1;
    }

    char ip[64];
    char message[MAX_LINE_LENGTH];

    printf("ITGManager started. Reading commands from file: %s\n", FILE_PATH);

    while (fscanf(file, "%63s %[^\n]", ip, message) == 2) {
        printf("Sending to %s: %s\n", ip, message);
        DITGsend(ip, message);
    }

    fclose(file);
    printf("All commands sent successfully.\n");
    return 0;
}