import socket
import time
import threading
import queue
import subprocess
import os
import json
import random

# import numpy as np
# import matplotlib.pyplot as plt

os.environ["LD_LIBRARY_PATH"] = "/home/osboxes/D-ITG-2.8.1-r1023-src/D-ITG-2.8.1-r1023/bin:" + os.environ.get("LD_LIBRARY_PATH", "")

ip_queue = queue.Queue()

# Configuration
LISTEN_PORT = 12347  # Specify the port number to listen on
num_machine = 0
map_point = {}
traffic_matrix = {}
f = 0
A = []
p_NAT = 0
P_values = []
MAX_TOTAL_TRAFFIC = 5000  # Pkts/s
PROTO = "UDP"
TIME_GENERATE = 3600000  # ms
PREF_CTRL_AS_PERCEN = 1

file_path = "/home/osboxes/D-ITG-2.8.1-r1023-src/D-ITG-2.8.1-r1023/bin/commands.txt"


def generate_and_send_traffic_matrix():
    global map_point, traffic_matrix, f, A, p_NAT, num_machine, P_values, PROTO, TIME_GENERATE

    listen_port_map = {}
    point_ips = sorted(map_point.keys(), key=lambda ip_term: tuple(map(int, ip_term.split('.'))))
    for i in range(len(point_ips)):
        point_ip_send = point_ips[i]
        if point_ip_send not in traffic_matrix:
            traffic_matrix[point_ip_send] = {}
            listen_port_map[point_ip_send] = 8999

        for j in range(len(point_ips)):
            point_ip_recv = point_ips[j]

            if point_ip_send == point_ip_recv:
                mean_rate = 0
            elif not A:
                mean_rate = 1000
            else:
                mean_rate = round((f * A[i] * P_values[j]) / sum(P_values) + ((1 - f) * A[j] * P_values[i]) / sum(P_values))
                # print(f"{i}->{j}", "mean_rate", mean_rate, "Ai", A[i], "P_values j", P_values[j], "P_values i", P_values[i], "Aj", A[j], "f", f)

            traffic_matrix[point_ip_send][point_ip_recv] = mean_rate

    trace_receive = {}
    for src_ip, dests in traffic_matrix.items():
        for dest_ip, mean_rate in dests.items():
            if src_ip != dest_ip:
                with open(file_path, "w") as file:
                    dest_port = listen_port_map[dest_ip]
                    command = f"-T {PROTO} -a {dest_ip} -rp {dest_port} -O {mean_rate} -o 512 -t {TIME_GENERATE}"
                    listen_port_map[dest_ip] += 1
                    file.write(f"{src_ip} {command}\n")
                    print(command)

                if dest_ip not in trace_receive:
                    trace_receive[dest_ip] = 0
                trace_receive[dest_ip] += mean_rate

                # print(f"Commands written to {file_path}")
                itg_manager_path = "/home/osboxes/D-ITG-2.8.1-r1023-src/D-ITG-2.8.1-r1023/bin/ITGManager"
                process = subprocess.Popen([itg_manager_path], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
                stdout, stderr = process.communicate()
                time.sleep(0.5)  # sleep to not overflow generator tool
                # print("Output:", stdout.decode())
                # print("Error:", stderr.decode())

    for ip, receive_rate in trace_receive.items():
        print("IP:", ip, " should received rate:", receive_rate)


def connect_attackers(ip):
    c_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    try:
        c_socket.connect((ip, 12345))
        c_socket.close()
    except Exception:
        pass


def notify_window_attacker():
    global map_point
    point_ips = map_point.keys()
    for point_ip_send in point_ips:
        threading.Thread(target=connect_attackers, args=[point_ip_send]).start()

    print("Finished sending attack demands")


def generate_pref_AS_choices(n, percent):
    num_ones = round(n * percent / 100)
    result = [1] # the first one is attacker always prefer the ctrl AS
    if num_ones > 0:
        array = [1] * (num_ones - 1) + [0] * (n - 1 - num_ones)
    else:
        array = [0] * (n - 1)

    random.shuffle(array)
    return result + array


def notify_ubuntu_internode():
    global map_point, PREF_CTRL_AS_PERCEN

    point_ips = map_point.keys()
    pref_as_array = generate_pref_AS_choices(len(point_ips), PREF_CTRL_AS_PERCEN)
    for point_ip_send in point_ips:
        array_to_send = []
        for point_ip_recv in point_ips:
            if point_ip_send != point_ip_recv:
                array_to_send.append(point_ip_recv)

        message = json.dumps({
            'handled_ips': array_to_send,
            'p_NAT': p_NAT,
            'is_pref_ctrl_as': pref_as_array[int(point_ip_send.split(".")[2]) - 1]
        }).encode('utf-8')
        udp_socket = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        try:
            print(f"Sending to {point_ip_send}...")
            time_retry = 3
            while time_retry > 0:
                udp_socket.sendto(message, (point_ip_send, 5000))  # Send to port 5000
                time_retry -= 1
        except Exception as e:
            print(f"Error sending to {point_ip_send}: {e}")
        udp_socket.close()


def read_and_write_points():
    global map_point
    while True:
        try:
            ip_client = ip_queue.get()
            if ip_client[1] not in map_point.keys():
                map_point[ip_client[1]] = 1
                print(len(map_point.keys()), "machines has connected - IP:", ip_client[1])

                if len(map_point.keys()) == num_machine:
                    notify_ubuntu_internode()
                    input("Press Enter to start traffic generation")
                    # time.sleep(3) # Sleep to wait the last windows finish opening the generator tool
                    generate_and_send_traffic_matrix()
                    input("Press Enter to start attack")
                    notify_window_attacker()
            else:
                print("IP crashed:", ip_client[1])
        except queue.Empty:
            pass


def get_parameters():
    HOST = "192.168.122.1"
    PORT = 12348
    client = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    client.connect((HOST, PORT))
    data = b""
    while True:  # Read until all data is received
        chunk = client.recv(1024)
        if not chunk:
            break
        data += chunk

    try:
        data_js = json.loads(data.decode('utf-8'))
        A_raw = data_js['A_raw']
        f_raw = data_js['f']  # Fixed
        num_machine_raw = data_js['num_host']
        p_NAT_raw = data_js['p_NAT']
        P_values_raw = data_js['P_values']
        max_total_traffic = data_js['max_total_traffic']
        proto = data_js['proto']
        time_generate = data_js['time_generate']
        pref_ctrl_as_percen = data_js['pref_ctrl_as_percen']
        # print(f"Received: {data_js}")  # Debugging

        client.close()
        return A_raw, f_raw, num_machine_raw, p_NAT_raw, P_values_raw, max_total_traffic, proto, time_generate, pref_ctrl_as_percen
    except json.JSONDecodeError:
        print("Invalid JSON received")


def run_monitor_infect():
    global num_machine

    tcp_listener_file = f"/home/osboxes/gns3_unikernel_testbed/window/tcp_listener.py"
    command = [
        "python3",
        tcp_listener_file,
        str(num_machine),
    ]
    command_str = " ".join(command)

    try:
        subprocess.Popen(
            ['xterm', '-hold', '-e', command_str],
            stdout=subprocess.DEVNULL,
            stderr=subprocess.DEVNULL,
            stdin=subprocess.DEVNULL,
            start_new_session=True
        )
    except subprocess.CalledProcessError as e:
        print(f"Error executing command {command_str}: {e}")


def main():
    global num_machine, f, A, p_NAT, P_values, MAX_TOTAL_TRAFFIC, PROTO, TIME_GENERATE, PREF_CTRL_AS_PERCEN

    A_raw, f, num_machine, p_NAT, P_values, MAX_TOTAL_TRAFFIC, PROTO, TIME_GENERATE, PREF_CTRL_AS_PERCEN = get_parameters()

    run_monitor_infect()
    if A_raw:
        A = [0] * num_machine
        for src_node, value in A_raw.items():
            i = int(src_node)
            for dst_node, rate in value.items():
                j = int(dst_node)
                A[i] += rate
                A[j] += rate

        scale_factor = MAX_TOTAL_TRAFFIC / max(A)
        for i in range(len(A)):
            A[i] *= scale_factor
            print(f"A[{i}]", A[i])

    thread = threading.Thread(target=read_and_write_points)
    thread.daemon = True
    thread.start()

    with socket.socket(socket.AF_INET, socket.SOCK_STREAM) as server_socket:
        server_socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        server_socket.bind(('0.0.0.0', LISTEN_PORT))
        server_socket.listen()

        print(f"Listening for incoming connections on port {LISTEN_PORT}...")

        while True:
            client_socket, client_address = server_socket.accept()
            ip_queue.put([time.time(), client_address[0]])


if __name__ == "__main__":
    main()

# P_values = generate_lognormal(11)
# print(P_values)
# plt.figure(figsize=(8, 5))
# plt.hist(P_values, bins=100, density=True, log=True, alpha=0.7, color='blue', edgecolor='black')
# plt.xlabel("P values")
# plt.ylabel("Frequency (log scale)")
# plt.title("Histogram of Pareto-Distributed Preference Values")
# plt.show()
